#include <stdio.h>
#include <stdlib.h>

void convert(unsigned short *data)
{
 *data = ((*data & 0x0FFF) >> 2) +  ((*data & 0x0003) << (8+6))
        +((*data & 0xC000) >> (15-10));
}

void main(int argc, char *argv[])
{
 FILE *F;
 unsigned short *data, *org;
 unsigned long i,j;

 if (argc < 2)
    {
     printf("Usage: %s file.lvl\n",argv[0]);
     exit(1);
    }

 F = fopen(argv[1],"rb");
 if (!F)
    {
     printf("Can't open %s\n",argv[1]);
     exit(1);
    }
 org = data = malloc(1000000);
 if (!org)
    {
    printf("Can't alloc 1Mb !\n");
    exit(1);
    }
 i = fread(org,sizeof(short),1000000,F);
 fclose(F);
 printf("Read %u words.\n",i);

 printf("Conversion...\n");
 for( j = 0 ; j < i ;j++)
      convert(data++);

 F = fopen(argv[1],"wb");
 if (!F)
    {
     printf("Can't open %s\n",argv[1]);
     exit(1);
    }
 j = fwrite(org,sizeof(short),i,F);
 fclose(F);
 printf("Write %u words.\n",j);
 free(org);
}
